package body Museum is

   protected body Guardian is
      entry Entrance
        when (Entrance'Count = Group_Size or Release) is
      begin
         --  the first time we reach here
         --+ it must be because ('Count = Group_Size)
         --+ hence we must make sure that we do not
         --+ allow more visitors in than the Museum
         --+ regulations specify
         --+
         --+ of course, as soon as we let visitors in
         --+ we have ('Count /= Group_Size)
         --+ hence we must make sure that the value
         --+ of Release keeps the guard open until
         --+ the last visitor of the group has entered
         if Entrance'Count = 0 then
            Release := False;
         else
            Release := True;
         end if;
      end Entrance;
   end Guardian;

end Museum;
